package text;

import java.util.Iterator;
import java.util.NoSuchElementException;

public class StyleDecorator extends AbstractComponentWithoutChildren {
	private Component component;
	private Style style;
	
	public StyleDecorator(Component component, Style style) {
		this.component = component;
		this.style = style;
	}

	@Override
	public Iterator<Node> iterator() {
		return new NodeIterator() {
			private Iterator<Node> state = new NodeIterator() {
				@Override
				public Node next() {
					state = new NodeIterator() {
						private Iterator<Node> iter = component.iterator();
						
						@Override
						public Node next() {
							if (iter.hasNext()) {
								return iter.next();
							}
							state = new NodeIterator() {
								@Override
								public Node next() {
									throw new NoSuchElementException();
								}
								
								@Override
								public boolean hasNext() {
									return false;
								}
							};
							return new EndElementNode(style.toString());
						}
						
						@Override
						public boolean hasNext() {
							return true;
						}
					};
					return new ElementNode(style.toString());
				}
				
				@Override
				public boolean hasNext() {
					return true;
				}
			};
			
			@Override
			public Node next() {
				return state.next();
			}
			
			@Override
			public boolean hasNext() {
				return state.hasNext();
			}
		};
	}
}